var app = new Vue({
    el: '#app',
    data: {
        baseUrl: '/Home/LoggedInSuccess?',
        popupActivated: false,
        wref: {},
        debugMode: false,
        persistedParameters: {
            landingpageVersion: '1.04',
            advancedOptions: false,
            idp: {
                mitid: false,
                mitiddemo: true,
                nemid: true
            },
            mitidSpecific: {
                acr: [],
                reference_text: '',
                transactionSigning: false,
                transaction_sign_type: 'html',
                transaction_sign_content_html: '<html>\r\n <style>\r\n  ul{\r\n      list-style: none;\r\n      margin: 0;\r\n      padding: 1rem;\r\n  }\r\n  ul li{\r\n      display: flex;\r\n      flex-direction: column;\r\n      margin-bottom: 2rem;\r\n  }\r\n\r\n  .key{\r\n      color: #adb5bd;\r\n      font-size: 90%;\r\n      margin-bottom: 5px;\r\n      text-transform: uppercase;\r\n  }\r\n  .value{\r\n      font-weight: bold;\r\n  }\r\n <\/style>\r\n <body>\r\n  <ul>\r\n   <li>\r\n    <div class=\"key\">From Account<\/div>\r\n    <div class=\"value\">Salary (51 3184 8481)<\/div>\r\n   <\/li>\r\n   <li>\r\n    <div class=\"key\">Reciever<\/div>\r\n    <div class=\"value\">EON (1551 458484448)<\/div>\r\n   <\/li>\r\n   <li>\r\n    <div class=\"key\">Reference<\/div>\r\n    <div class=\"value\">Invoice #15418144<\/div>\r\n   <\/li>\r\n   <li>\r\n    <div class=\"key\">Date<\/div>\r\n    <div class=\"value\">24 February 2020<\/div>\r\n   <\/li>\r\n   <li>\r\n    <div class=\"key\">Amount<\/div>\r\n    <div class=\"value total\">18.484,05<small> DKK<\/small><\/div>\r\n   <\/li>\r\n  <\/ul>\r\n <\/body>\r\n<\/html>',
                transaction_sign_content_plain: 'Type your sign text here',
                require_psd2: false
            },
            mitiddemoSpecific: {
                acr: [],
                reference_text: '',
                transactionSigning: false,
                transaction_sign_type: 'html',
                transaction_sign_content_html: '<html>\r\n <style>\r\n  ul{\r\n      list-style: none;\r\n      margin: 0;\r\n      padding: 1rem;\r\n  }\r\n  ul li{\r\n      display: flex;\r\n      flex-direction: column;\r\n      margin-bottom: 2rem;\r\n  }\r\n\r\n  .key{\r\n      color: #adb5bd;\r\n      font-size: 90%;\r\n      margin-bottom: 5px;\r\n      text-transform: uppercase;\r\n  }\r\n  .value{\r\n      font-weight: bold;\r\n  }\r\n <\/style>\r\n <body>\r\n  <ul>\r\n   <li>\r\n    <div class=\"key\">From Account<\/div>\r\n    <div class=\"value\">Salary (51 3184 8481)<\/div>\r\n   <\/li>\r\n   <li>\r\n    <div class=\"key\">Reciever<\/div>\r\n    <div class=\"value\">EON (1551 458484448)<\/div>\r\n   <\/li>\r\n   <li>\r\n    <div class=\"key\">Reference<\/div>\r\n    <div class=\"value\">Invoice #15418144<\/div>\r\n   <\/li>\r\n   <li>\r\n    <div class=\"key\">Date<\/div>\r\n    <div class=\"value\">24 February 2020<\/div>\r\n   <\/li>\r\n   <li>\r\n    <div class=\"key\">Amount<\/div>\r\n    <div class=\"value total\">18.484,05<small> DKK<\/small><\/div>\r\n   <\/li>\r\n  <\/ul>\r\n <\/body>\r\n<\/html>',
                transaction_sign_content_plain: 'Type your sign text here'
            },
            nemidSpecific: {
                acr: ['https://netsbroker/loa/nemid/otp'],
                apptransactiontext: '',
                nemid_private_to_business: false,
                transactionSigning: false,
                transaction_sign_type: '',
                transaction_sign_content_plain: 'Type your sign text here'
            },
            uxType: '',
            ssn: false,
            transactionToken: false,
            userinfoToken: false
        }
    },
    computed: {
        queryBuilder: function () {
            let paramsValues = {}
            let scope = []
            let acr = []
            if (this.persistedParameters.mitiddemoSpecific.transactionSigning) {
                paramsValues.mitiddemo_sign_text_type = this.persistedParameters.mitiddemoSpecific.transaction_sign_type
                if (paramsValues.mitiddemo_sign_text_type === 'html') {
                    paramsValues.mitiddemo_sign_text = this.b64(this.persistedParameters.mitiddemoSpecific.transaction_sign_content_html)
                } else {
                    paramsValues.mitiddemo_sign_text = this.b64(this.persistedParameters.mitiddemoSpecific.transaction_sign_content_plain)
                }
            }
            if (this.persistedParameters.mitidSpecific.transactionSigning) {
                paramsValues.mitid_sign_text_type = this.persistedParameters.mitidSpecific.transaction_sign_type
                if (paramsValues.mitid_sign_text_type === 'html') {
                    paramsValues.mitid_sign_text = this.b64(this.persistedParameters.mitidSpecific.transaction_sign_content_html)
                } else {
                    paramsValues.mitid_sign_text = this.b64(this.persistedParameters.mitidSpecific.transaction_sign_content_plain)
                }
            }
            if (this.persistedParameters.nemidSpecific.transactionSigning) {
                paramsValues.nemid_sign_text_type = this.persistedParameters.nemidSpecific.transaction_sign_type
                if (paramsValues.nemid_sign_text_type === 'text') {
                    paramsValues.nemid_sign_text = this.b64(this.persistedParameters.nemidSpecific.transaction_sign_content_plain)
                } else {
                    paramsValues.nemid_signpdf = true
                }
            }
            paramsValues.mitidEnabled = this.persistedParameters.idp.mitid
            paramsValues.mitiddemoEnabled = this.persistedParameters.idp.mitiddemo
            paramsValues.nemidEnabled = this.persistedParameters.idp.nemid
            if (paramsValues.nemidEnabled) {
                scope.push('nemid')
                acr = acr.concat(this.persistedParameters.nemidSpecific.acr)
                paramsValues.nemid_private_to_business = this.persistedParameters.nemidSpecific.nemid_private_to_business
            }
            if (paramsValues.mitidEnabled) {
                scope.push('mitid')
                acr = acr.concat(this.persistedParameters.mitidSpecific.acr)
            }
            if (paramsValues.mitiddemoEnabled) {
                scope.push('mitid_demo')
                acr = acr.concat(this.persistedParameters.mitiddemoSpecific.acr)
            }
            if (acr.length > 0) {
                paramsValues.acr = acr.join(' ')
            }
            if (this.persistedParameters.ssn) {
                scope.push('ssn')
            }
            if (this.persistedParameters.transactionToken) {
                scope.push('transaction_token')
            }
            if (this.persistedParameters.userinfoToken) {
                scope.push('userinfo_token')
            }
            if (scope.length > 0) {
                paramsValues.scope = scope.join(' ')
            }
            if (this.persistedParameters.mitiddemoSpecific.reference_text) {
                paramsValues.mitiddemo_reference_text = this.b64(this.persistedParameters.mitiddemoSpecific.reference_text)
            }
            if (this.persistedParameters.mitidSpecific.reference_text) {
                paramsValues.mitid_reference_text = this.b64(this.persistedParameters.mitidSpecific.reference_text)
            }
            if (this.persistedParameters.mitidSpecific.require_psd2) {
                paramsValues.mitid_require_psd2 = this.persistedParameters.mitidSpecific.require_psd2
            }
            if (this.persistedParameters.nemidSpecific.apptransactiontext) {
                paramsValues.nemid_apptransactiontext = this.b64(this.persistedParameters.nemidSpecific.apptransactiontext)
            }
            let paramsValuesEncoded = ''
            for (var prop in paramsValues) {
                if (paramsValues.hasOwnProperty(prop)) {
                    var k = encodeURIComponent(prop),
                        v = encodeURIComponent(paramsValues[prop])
                    paramsValuesEncoded = paramsValuesEncoded + k + "=" + v + '&'
                }
            }
            return paramsValuesEncoded.slice(0, -1)
        },
        formValid: function() {
            return this.idpSelected && this.mitIdValid && this.mitIddemoValid && this.uxSelected;
        },
        mitIdValid: function (){
            return this.persistedParameters.idp.mitid ? this.persistedParameters.mitidSpecific.acr.length > 0: true;
        },
        mitIddemoValid: function (){
            return this.persistedParameters.idp.mitiddemo ? this.persistedParameters.mitiddemoSpecific.acr.length > 0: true;
        },
        uxSelected: function (){
            return !(this.persistedParameters.uxType === '');
        },
        idpSelected: function (){
            return (this.persistedParameters.idp.mitiddemo || this.persistedParameters.idp.mitid || this.persistedParameters.idp.nemid)
        }
    },
    methods: {
        b64: function (content) {
            return btoa(unescape(encodeURIComponent(content)))
        },
        toggleAdvanced: function() {
            this.persistedParameters.advancedOptions = !this.persistedParameters.advancedOptions
        },
        basicSignin: function() {
            window.location.href = this.baseUrl
        },
        callOP: function(event) {
            if (event !== undefined) {
                event.preventDefault()
            }
            if(Object.keys(this.wref).length !== 0 && !this.wref.closed){
                this.onFocus()
            } else {
                if (this.persistedParameters.uxType === 'redirect') {
                    if (event !== undefined) {
                        event.target.reset()
                    }
                    window.location.href = this.baseUrl + this.queryBuilder
                }else if(this.persistedParameters.uxType==='popup'){
                    if(this.persistedParameters.transactionSigning){
                        this.popupwindow(this.baseUrl+this.queryBuilder, 'Sign in','900','710')
                    } else {
                        this.popupwindow(this.baseUrl + this.queryBuilder, 'Sign in', '452', '640')
                    }
                }
            }
        },
        popupwindow: function(n, t, i, r){
            this.popupActivated = true
            let u = window.outerHeight / 2 + window.screenY - r / 2
            let f = window.outerWidth / 2 + window.screenX - i / 2
            this.wref = window.open(n, t, 'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width=' + i + ', height=' + r + ', top=' + u + ', left=' + f)
            this.wref.focus()
        },
        onFocus: function(){
            if(Object.keys(this.wref).length !== 0){
                setTimeout(function () { app.wref.focus() }, 100)
            }
        },
        closeWindow: function(){
            if(Object.keys(this.wref).length !== 0){
                this.wref.close()
                this.popupActivated = false
                this.wref = {}
            }
            this.popupActivated = false
        },
        receiveMessage: function(event){
            if (event.data === 'CLOSE') {
                this.closeWindow()
            } else if (event.data === 'SUCCESS') {
                this.closeWindow()
                window.location.href = '/Secure/Claims'
            }
        }
    },
    created: function() {
        window.addEventListener("message", this.receiveMessage, false)
        window.addEventListener("focus", this.onFocus)
        if (location.hostname === "localhost") {
            this.debugMode = true
        }
    }
})